#Compile Exe
#Include "win32api.inc"
Global key2() As Double
Global p As Double, q As Double
Global PHI As Double

Declare Function dec(tIp As String, dD As Double, dN As Double) As String
Declare Function enc(tIp As String, eE As Double, eN As Double) As String
Declare Function nMod(x As Double, y As Double) As Double
Declare Function Mult(ByVal x As Double, ByVal p As Double, ByVal m As Double) As Double
Declare Function IsPrime(lngNumber As Double) As Byte
Declare Function GCD(nPHI As Double) As Double
Declare Function Euler(E3 As Double, PHI3 As Double) As Double
Declare Sub keyGen()

%PQ_UP = 9999 'set upper limit of random number
%PQ_LW = 3170 'set lower limit of random number
%KEY_LOWER_LIMIT = 10000000 'set for 64bit minimum

Sub keyGen()
'Generates the keys for E, D and N
Dim E#, D#, N#
p = 0: q = 0
Randomize Timer
Do Until D > %KEY_LOWER_LIMIT 'makes sure keys are 64bit minimum
Do Until IsPrime(p) And IsPrime(q) ' make sure q and q are primes
p = Int((%PQ_UP - %PQ_LW + 1) * Rnd + %PQ_LW)
q = Int((%PQ_UP - %PQ_LW + 1) * Rnd + %PQ_LW)
Loop
    N = p * q
    PHI = (p - 1) * (q - 1)
    E = GCD(PHI)
    D = Euler(E, PHI)
Loop
        key2(1) = E
        key2(2) = D
        key2(3) = N
End Sub

Function Euler(E3 As Double, PHI3 As Double) As Double
'genetates D from (E and PHI) using the Euler algorithm
On Error Resume Next
Dim u1#, u2#, u3#, v1#, v2#, v3#, q#
Dim t1#, t2#, t3#, z#, uu#, vv#, inverse#
u1 = 1
u2 = 0
u3 = PHI3
v1 = 0
v2 = 1
v3 = E3
Do Until (v3 = 0)
     q = Int(u3 / v3)
     t1 = u1 - q * v1
     t2 = u2 - q * v2
     t3 = u3 - q * v3
     u1 = v1
     u2 = v2
     u3 = v3
     v1 = t1
     v2 = t2
     v3 = t3
     z = 1
Loop
uu = u1
vv = u2
If (vv < 0) Then
          inverse = vv + PHI3
Else
     inverse = vv
End If
Euler = inverse
End Function

%N_UP = 99999999 'set upper limit of random number for E
%N_LW = 10000000 'set lower limit of random number for E

Function GCD(nPHI As Double) As Double
'generates a random number relatively prime to PHI
On Error Resume Next
Dim nE#, y#
Dim x As Double
Randomize
nE = Int((%N_UP - %N_LW + 1) * Rnd + %N_LW)
top:
    x = nPHI Mod nE
    y = x Mod nE
    If y <> 0 And IsPrime(nE) Then
        GCD = nE
        Exit Function
    Else
        nE = nE + 1
    End If
    GoTo top
End Function
Function IsPrime(lngNumber As Double) As Byte
'Returns '%TRUE' if lngNumber is a prime
On Error Resume Next
Dim lngCount#
Dim lngSqr#
Dim x#
lngSqr = Int(Sqr(lngNumber)) ' Get the int square root
    If lngNumber < 2 Then
        IsPrime = %FALSE
        Exit Function
    End If
    lngCount = 2
    IsPrime = %TRUE
    If lngNumber Mod lngCount = 0 Then
        IsPrime = %FALSE
        Exit Function
    End If
    lngCount = 3
    For x = lngCount To lngSqr Step 2
        If lngNumber Mod x = 0 Then
            IsPrime = %FALSE
            Exit Function
        End If
    Next
End Function

Function Mult(ByVal x As Double, ByVal p As Double, ByVal m As Double) As Double
Dim y As Double
'encrypts, decrypts values passed to the function.. e.g.
'Mult = M^E mod N (encrypt)  where M = x , E = p, N = m
'Mult = M^D mod N (decrypt)
On Error GoTo error1
y = 1
    Do While p > 0
        Do While (p / 2) = Int((p / 2))
            x = nMod((x * x), m)
            p = p / 2
        Loop
        y = nMod((x * y), m)
        p = p - 1
    Loop
    Mult = y
    Exit Function
error1:
y = 0
End Function

Function nMod(x As Double, y As Double) As Double
'this function replaces the Mod command. instead of z = x Mod y
'it is now  z = nMod(x,y)
On Error Resume Next
Dim z#
z = x - (Int(x / y) * y)
nMod = z
End Function

Function GoHex(xLng As Long) As String
On Error Resume Next
Dim I As Long
Dim xStr As String
Dim OutStr$
xStr = Right$("00000000" & Trim$(Str$(xLng)), 8)
For I = 1 To Len(xStr)
 OutStr$ = OutStr$ & Chr$(Val("&h" & Mid$(xStr, I, 2)))
 ! inc I
Next I
Function = OutStr$
End Function
Function enc(tIp As String, eE As Double, eN As Double) As String
On Error Resume Next
Dim encSt As String
Dim e2st As String
Dim I As Long
encSt = ""
e2st = ""
If tIp = "" Then Exit Function
For i = 1 To Len(tIp)
    encSt = encSt & GoHex(Mult(CLng(Asc(Mid$(tIp, i, 1))), eE, eN))
Next i
enc = encSt
End Function

Function dec(tIp As String, dD As Double, dN As Double) As String
On Error Resume Next
Dim decSt As String
Dim z As Long
Dim zptr As Long
Dim sTmp As String
Dim tok As Long
decSt = ""
For z = 1 To Len(tIp)
    sTmp = sTmp & Hex$(Asc(Mid$(tIp,z,1)),2)
    sTmp = sTmp & Hex$(Asc(Mid$(tIp,z+1,1)),2)
    sTmp = sTmp & Hex$(Asc(Mid$(tIp,z+2,1)),2)
    sTmp = sTmp & Hex$(Asc(Mid$(tIp,z+3,1)),2)
    tok = Val(sTmp)
    decSt = decSt + Chr$(Mult(tok, dD, dN))
    ! add z, 3
    sTmp = ""
Next z
dec = decSt
End Function


'/////////////////////////////////////////////////////
'// Demo program - creates private and public keys, //
'// then encrypts and decrypts a test string.       //
'/////////////////////////////////////////////////////
Function PBMain() As Long
ReDim key2(3) As Double
Dim EncStr As String
Dim DecStr As String
Dim PlainText As String
PlainText = "ABCDEFGHIJKLMNOPQRSTUVWXYZ 1234567890"   'The message to encrypt
keyGen
StdOut "Result:"
StdOut " p=" & Str$(p)
StdOut " q=" & Str$(q)
StdOut " PHI=" & Str$(PHI)
StdOut " E=" & Left$(Str$(Key2(1)) & Space$(12),12) & "PRIVATE KEY"
StdOut " D=" & Left$(Str$(Key2(2)) & Space$(12),12) & "PUBLIC KEY"
StdOut " N=" & Left$(Str$(Key2(3)) & Space$(12),12) & "PUBLIC KEY"
StdOut
StdOut "Plaintext: " & PlainText
EncStr = enc(Plaintext, key2(1), key2(3))
StdOut "Encrypted: " & EncStr
DecStr = dec(EncStr, key2(2), key2(3))
StdOut "Decrypted: " & DecStr
WaitKey$
End Function
