'=====================================================================
'                         RIPEMD-160 Test Bed code
'               Compiles with either PBWIN 7.0+ or PBCC 3.0+
'=====================================================================
#Compile Exe
#Register None
#Dim All
'============
DefLng A-Z
'--------------------
'-- Utility macros
'--------------------
#If %Def(%PB_Win32)
   Macro eol=$Cr
   Macro mbox(t)=MsgBox t
#ElseIf %Def(%PB_CC32)
   Macro eol=$CrLf
   Macro mbox(t)=stdout t
#EndIf
'--------------------
Macro EnterCC
#If %Def(%PB_CC32)
   Local launched&
   If (cursory = 1) And (cursorx = 1) Then launched = -1
#EndIf
End Macro
'--------------------
Macro ExitCC
#If %Def(%PB_CC32)
   If launched Then
      Input Flush
      stdout "Press any key to end"
      WaitKey$
   End If
#EndIf
End Macro
'--------------------
' MACRO zbs(x)=string$(x,0) 'also defined in RMD160.BAS
' %HASHLENGTH    = 20     'bytes
' %BLOCKSIZE     = 64     'bytes
' TYPE HASH_CONTEXT
'  pBuffer      AS LONG PTR
'  BufferLength AS LONG
'  MD           AS LONG PTR
'  MD_Buffer    AS STRING * %HASHLENGTH
' END TYPE

#Include "RMD160.INC"

Declare Function Hex2Show$(Buffer$)
'====================
Function PBMain&()
  Local i&, plain$, hash$, shouldbe$, t$
  Local ctx As HASH_CONTEXT  ' defined in RMD160.BAS
  EnterCC
  ' -- Standard RIPEMD-160 test vectors:
  plain    = ""        'empty string
  hash     = zbs(%HASHLENGTH)
  shouldbe = Chr$(&h9c,&h11,&h85,&ha5,&hc5,&he9,&hfc,&h54,&h61,&h28,&h08,&h97,&h7e,&he8,&hf5,&h48,&hb2,&h25,&h8d,&h31)
  t = "plain:    " + plain + eol
  GoSub DoRMD160
  t = t + "hash:     " + Hex2Show$(hash) + eol
  t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol + eol
  plain    = "a"
  hash     = zbs(%HASHLENGTH)
  shouldbe = Chr$(&h0b,&hdc,&h9d,&h2d,&h25,&h6b,&h3e,&he9,&hda,&hae,&h34,&h7b,&he6,&hf4,&hdc,&h83,&h5a,&h46,&h7f,&hfe)
  t = T + "plain:    " + plain + eol
  GoSub DoRMD160
  t = t + "hash:     " + Hex2Show$(hash) + eol
  t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol + eol
  plain    = "message digest"
  hash     = zbs(%HASHLENGTH)
  shouldbe = Chr$(&h5d,&h06,&h89,&hef,&h49,&hd2,&hfa,&he5,&h72,&hb8,&h81,&hb1,&h23,&ha8,&h5f,&hfa,&h21,&h59,&h5f,&h36)
  t = t + "plain:    " + plain + eol
  GoSub DoRMD160
  t = t + "hash:     " + Hex2Show$(hash) + eol
  t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol + eol
  plain    = Repeat$(1000000,"a")
  hash     = zbs(%HASHLENGTH)
  shouldbe = Chr$(&h52,&h78,&h32,&h43,&hc1,&h69,&h7b,&hdb,&he1,&h6d,&h37,&hf9,&h7f,&h68,&hf0,&h83,&h25,&hdc,&h15,&h28)
  t = t + "Million chars test" + eol
  GoSub DoRMD160
  t = t + "hash:     " + Hex2Show$(hash) + eol
  t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol + eol
  mbox(t)
  '============
  ExitPBMain:
  ExitCC
  Exit Function
'============
    DoRMD160:
    Register bufflen&
    ctx.pBuffer      = StrPtr(plain)
    ctx.BufferLength = Len(plain)
    RMD160_Init ctx
    bufflen = ctx.BufferLength
    Do While bufflen > (%BLOCKSIZE-1)
       Compress ctx
       ctx.pBuffer = ctx.pBuffer + %BLOCKSIZE
       bufflen = bufflen - %BLOCKSIZE
    Loop
    MDfinish ctx
    hash = Peek$(Ctx.MD, %HASHLENGTH)
    Return
End Function
'====================
Function Hex2Show$(Buffer$)
    Register i&
    Local t$, b As Byte Ptr
    b = StrPtr(Buffer$)
    For i = 0 To Len(Buffer$)-1
       t = t + Hex$(@b[i],2) + " "
    Next i
    Function = t
End Function
'-- end TESTBED.BAS
