'=====================================================================
'-- SHA256.BAS
'-- Test bed for SHA256.INC
'-- Compiles with either PBDLL or PBCC
'=====================================================================
#Compile Exe
#Dim All
#Register None

DefLng A-Z
'============
#Include "WIN32API.INC"
#Include "SHA256.INC"

Declare Sub VerifyImplementation()
Declare Function ShowHash&(ShouldBe$, Hash$)
Declare Function ShowText&(T$)

'====================
Function PBMain&()
Register i&
Local file_name$, t$, hash$, ecode&
Local pdword As Dword Ptr

#If %Def(%PB_CC32)
Local launched&
If (cursory = 1) And (cursorx = 1) Then launched& = -1
#EndIf

Call VerifyImplementation

file_name$ = "c:\autoexec.bat"
ecode& = SHA_File&(file_name$, hash$)

If ecode& Then
   ShowText file_name$ + $Cr + "Error: " + Str$(ecode&)
Else
   pdword = StrPtr(hash$)
   t$ = file_name$ + $Cr
   For i& = 0 To 7
      t$ = t$ + Hex$(@pdword[i&], 8) + " "
   Next i&
   t$ = RTrim$(t$," ") + $Cr
   ShowText t$
End If

Function = ecode&
'============
ExitPBMain:
#If %Def(%PB_CC32)
If launched& Then
   Input Flush
   mouse 1, down : mouse On
   Print "Click or press any key to end";
   WaitKey$
End If
#EndIf
End Function


'====================
Sub VerifyImplementation()
Local buffer$, sha$, shouldbe$
GoSub TestVectors1
GoSub TestVectors2
GoSub TestVectors3
GoSub TestVectors4
Exit Sub

'============
TestVectors1:
buffer$ = "abc"
sha$ = String$(32,0)
SHA_Buffer ByVal StrPtr(buffer$), Len(buffer$), ByVal StrPtr(sha$)
shouldbe$ = "BA7816BF 8F01CFEA 414140DE 5DAE2223 B00361A3 96177A9C B410FF61 F20015AD"
ShowHash shouldbe$, sha$
Return

'============
TestVectors2:
buffer$ = "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"
sha$ = String$(32,0)
SHA_Buffer ByVal StrPtr(buffer$), Len(buffer$), ByVal StrPtr(sha$)
shouldbe$ = "248D6A61 D20638B8 E5C02693 0C3E6039 A33CE459 64FF2167 F6ECEDD4 19DB06C1"
ShowHash shouldbe$, sha$
Return

'============
TestVectors3:
buffer$ = "abcdefghbcdefghicdefghijdefghijkefghijklfghijklmghijklmnhij"
buffer$ = buffer$ + "klmnoijklmnopjklmnopqklmnopqrlmnopqrsmnopqrstnopqrstu"
sha$ = String$(32,0)
SHA_Buffer ByVal StrPtr(buffer$), Len(buffer$), ByVal StrPtr(sha$)
shouldbe$ = "CF5B16A7 78AF8380 036CE59E 7B049237 0B249B11 E8F07A51 AFAC4503 7AFEE9D1"
ShowHash shouldbe$, sha$
Return

'============
TestVectors4:
buffer$ = String$(1000000,"a")
sha$ = String$(32,0)
SHA_Buffer ByVal StrPtr(buffer$), Len(buffer$), ByVal StrPtr(sha$)
shouldbe$ = "CDC76E5C 9914FB92 81A1C7E2 84D73E67 F1809A48 A497200E 046D39CC C7112CD0"
ShowHash shouldbe$, sha$
Return
End Sub


'====================
Function ShowHash&(ShouldBe$, Hash$)
Register i&
Local t$, pdword As Dword Ptr
t$ = "Should be:" + $Cr + shouldbe$ + $Cr
pdword = StrPtr(Hash$)
t$ = t$ + "Actual: " + $Cr
For i& = 0 To 7
   t$ = t$ +  Hex$(@pdword[i&], 8) + " "
Next i&
ShowText t$
End Function


'====================
Function ShowText&(T$)
'-- Text display for PBCC and PBDLL
'-- Note: Destroys T$ under PBCC

#If %Def(%PB_CC32)
If InStr(T$, $Cr) = 0 Then
   Print T$
Else
   Local tt$
   '-- Be sure of trailing $CR
   T$ = RTrim$(T$, $Cr) + $Cr
   Do While Len(T$)
      tt$ = Extract$(T$, $Cr)
      Print tt$
      T$ = Remain$(T$, $Cr)
   Loop
End If

#ElseIf %Def(%PB_Dll32)
MsgBox T$
#EndIf
End Function
