




'################################################################
'CRC32, by Semen Matusovski.
'Modified by Wayne Diamond to use a global CRCTable which only
'needs to be initialised once.

#Compile Exe

Global sCrcTable As String * 1024, PtrCRC As Dword Pointer

Sub Crc32_BuildTable(ByVal MagWord As Long)
    Dim x As Dword Pointer
    x = VarPtr(sCrcTable)
      ! MOV EDI, PtrCRC
      ! MOV EDX, 0
 Crc32_BuildTable_Lb1:
      ! MOV EBX, EDX
      ! MOV ECX, 8
 Crc32_BuildTable_Lb2:
      ! MOV EAX, EBX
      ! AND EAX, 1
      ! JE Crc32_BuildTable_Lb3
      ! SHR EBX, 1
      ! MOV EAX, MagWord
      ! XOR EBX, EAX
      ! JMP Crc32_BuildTable_Lb4
 Crc32_BuildTable_Lb3:
      ! SHR EBX, 1
 Crc32_BuildTable_Lb4:
      ! DEC ECX
      ! JNZ Crc32_BuildTable_Lb2
      ! MOV [EDI], EBX
      ! ADD EDI, 4
      ! INC EDX
      ! CMP EDX, 255
      ! JLE Crc32_BuildTable_Lb1
End Sub

Function Crc32_Calculate (ByVal Address As Dword, ByVal Length As Long, _
      sCrcTable As String * 1024, ByVal InitCrc As Long, ByVal Inverse As Long) As Long
      ! MOV EBX, InitCrc
      ! MOV EDI, Address
      ! MOV ESI, EDI
      ! ADD ESI, Length
 Crc32_Calculate_Lb1:
      ! CMP EDI, ESI
      ! JGE  Crc32_Calculate_Lb2
      ! MOV EAX, 0
      ! MOV AL, [EDI]
      ! XOR EAX, EBX
      ! AND EAX, &HFF
      ! SHL EAX, 2
      ! add EaX, PtrCRC  ;sCrcTable
      ! MOV EAX, [EAX]
      ! SHR EBX, 8
      ! AND EBX, &H00FFFFFF
      ! XOR EBX, EAX
      ! INC EDI
      ! JMP Crc32_Calculate_Lb1
  Crc32_Calculate_Lb2:
      ! CMP Inverse, 0
      ! JE  Crc32_Calculate_Lb3
      ! XOR EBX, &HFFFFFFFF
 Crc32_Calculate_Lb3:
      ! MOV Function, EBX
End Function

Function PBMain() As Long
     Dim Buffer As String, Crc As Long
     PtrCRC = VarPtr(sCrcTable)
     Buffer = "1234567890"
     Crc32_BuildTable &HEDB88320
     Crc = Crc32_Calculate (StrPtr(Buffer), Len(Buffer), sCrcTable, &HFFFFFFFF, 1)
     MsgBox Hex$(Crc) & " (should be 261DAEE5)",, "Winzip compatible CRC"
End Function
'################################################################
