'=====================================================================
'                       Rijndael Test Bed code
'               Compiles with either PBWIN 7.0+ or PBCC 3.0+
'=====================================================================

#Compile Exe
#Register None
'#Dim All

'============
DefLng A-Z

'--------------------
'-- Utility macros
'--------------------
#If %Def(%PB_Win32)
   Macro eol=$Cr
   Macro mbox(t)=MsgBox t
#ElseIf %Def(%PB_CC32)
   Macro eol=$CrLf
   Macro mbox(t)=StdOut t
#EndIf
'--------------------

Macro EnterCC
#If %Def(%PB_CC32)
   Local launched&
   If (CursorY = 1) And (CursorX = 1) Then launched = -1
#EndIf
End Macro
'--------------------

Macro ExitCC
#If %Def(%PB_CC32)
   If launched Then
      Input Flush
      StdOut "Press any key to end"
      WaitKey$
   End If
#EndIf
End Macro
'--------------------
'MACRO zbs(x)=string$(x,0) 'also defined in RIJNDAEL.BAS

#Include "RIJNDAEL.BAS"

Declare Function Hex2Show$(Buffer$)

'====================

Function PBMain&()
Register i&
Local Key$, plain$, cipher$, shouldbe$, t$
Local ctx As ENCRYPTION_CONTEXT  ' defined in RIJNDAEL.BAS
EnterCC
'-- Standard Rijndael test vectors (from ECB_TBL.TXT, I=1)
'-- 256-bit key
Key      = Chr$(&h00,&h01,&h02,&h03,&h05,&h06,&h07,&h08,&h0A,&h0B,&h0C,&h0D,&h0F,&h10,&h11,&h12, _
                &h14,&h15,&h16,&h17,&h19,&h1A,&h1B,&h1C,&h1E,&h1F,&h20,&h21,&h23,&h24,&h25,&h26)
plain    = Chr$(&h83,&h4E,&hAD,&hFC,&hCA,&hC7,&hE1,&hB3,&h06,&h64,&hB1,&hAB,&hA4,&h48,&h15,&hAB)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&h19,&h46,&hDA,&hBF,&h6A,&h03,&hA2,&hA2,&hC3,&hD0,&hB0,&h50,&h80,&hAE,&hD6,&hFC)
t = t + "Key length (bits):" + Str$(Len(Key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt
t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
Key      = Chr$(&h00,&h01,&h02,&h03,&h05,&h06,&h07,&h08,&h0A,&h0B,&h0C,&h0D,&h0F,&h10,&h11,&h12, _
                &h14,&h15,&h16,&h17,&h19,&h1A,&h1B,&h1C,&h1E,&h1F,&h20,&h21,&h23,&h24,&h25,&h26)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol
'-- 192-bit key
Key      = Chr$(&h00,&h01,&h02,&h03,&h05,&h06,&h07,&h08,&h0A,&h0B,&h0C,&h0D,&h0F,&h10,&h11,&h12, _
                &h14,&h15,&h16,&h17,&h19,&h1A,&h1B,&h1C)
plain    = Chr$(&h2D,&h33,&hEE,&hF2,&hC0,&h43,&h0A,&h8A,&h9E,&hBF,&h45,&hE8,&h09,&hC4,&h0B,&hB6)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&hDF,&hF4,&h94,&h5E,&h03,&h36,&hDF,&h4C,&h1C,&h56,&hBC,&h70,&h0E,&hFF,&h83,&h7F)
t = t + "Key length (bits):" + Str$(Len(Key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt
t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
Key      = Chr$(&h00,&h01,&h02,&h03,&h05,&h06,&h07,&h08,&h0A,&h0B,&h0C,&h0D,&h0F,&h10,&h11,&h12, _
                &h14,&h15,&h16,&h17,&h19,&h1A,&h1B,&h1C)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol
'-- 128-bit key
Key$     = Chr$(&h00,&h01,&h02,&h03,&h05,&h06,&h07,&h08,&h0A,&h0B,&h0C,&h0D,&h0F,&h10,&h11,&h12)
plain    = Chr$(&h50,&h68,&h12,&hA4,&h5F,&h08,&hC8,&h89,&hB9,&h7F,&h59,&h80,&h03,&h8B,&h83,&h59)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&hD8,&hF5,&h32,&h53,&h82,&h89,&hEF,&h7D,&h06,&hB5,&h06,&hA4,&hFD,&h5B,&hE9,&hC9)
t = t + "Key length (bits):" + Str$(Len(Key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt
t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
Key$     = Chr$(&h00,&h01,&h02,&h03,&h05,&h06,&h07,&h08,&h0A,&h0B,&h0C,&h0D,&h0F,&h10,&h11,&h12)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol
mbox(t)
ExitCC
Exit Function
'============
DoEncrypt:
ctx.action        = %ENCRYPT
ctx.UserKey       = StrPtr(Key)
ctx.UserKeyLength = Len(Key)
ctx.InBlock       = StrPtr(plain)
ctx.OutBlock      = StrPtr(cipher)
If Set_Key&(ctx) Then
   For i = 1 To (Len(plain) \ %BLOCKSIZE)  '<-- Required: (len(plain$) mod 16) = 0
      EncryptBlock ctx
      ctx.InBlock  = ctx.InBlock  + %BLOCKSIZE
      ctx.OutBlock = ctx.OutBlock + %BLOCKSIZE
   Next i&
Else
   mbox("DoEncrypt SetKey Error")
End If
'-- Burn the subkey
If Ctx.KE Then Poke$ Ctx.KE, zbs(SizeOf(Ctx.KE_Buffer))
If Ctx.KD Then Poke$ Ctx.KD, zbs(SizeOf(Ctx.KD_Buffer))
Return
'============
DoDecrypt:
ctx.action        = %DECRYPT
ctx.UserKey       = StrPtr(Key)
ctx.UserKeyLength = Len(Key)
ctx.InBlock       = StrPtr(cipher)
ctx.OutBlock      = StrPtr(plain)
If Set_Key&(ctx) Then
   For i = 1 To (Len(plain$)\%BLOCKSIZE)  '<-- Required: (len(plain$) mod 16) = 0
      DecryptBlock ctx
      ctx.InBlock  = ctx.InBlock  + %BLOCKSIZE
      ctx.OutBlock = ctx.OutBlock + %BLOCKSIZE
   Next i
Else
   mbox("DoDecrypt SetKey Error")
End If
'-- Burn the subkey
If Ctx.KE Then Poke$ Ctx.KE, zbs(SizeOf(Ctx.KE_Buffer))
If Ctx.KD Then Poke$ Ctx.KD, zbs(SizeOf(Ctx.KD_Buffer))
Return
End Function


'====================
Function Hex2Show$(Buffer$)
    Local t$, i&, b As Byte Ptr
    b = StrPtr(Buffer$)
    For i = 0 To Len(Buffer$)-1
       t = t + Hex$(@b[i],2) + " "
    Next i
    Function = t
End Function
'-- end TESTBED.BAS


'------------------
' -- Greg
' gturgeon@compuserve.com
