

'=====================================================================
'                         Serpent Test Bed code
'               Compiles with either PBWIN 7.0+ or PBCC 3.0+
'=====================================================================
#Compile Exe
#Register None
#Dim All
'============
DefLng A-Z
'--------------------
'-- Utility macros
'--------------------
#If %Def(%PB_Win32)
   Macro eol=$Cr
   Macro mbox(t)=MsgBox t
#ElseIf %Def(%PB_CC32)
   Macro eol=$CrLf
   Macro mbox(t)=stdout t
#EndIf
'--------------------
Macro EnterCC
#If %Def(%PB_CC32)
   Local launched&
   If (cursory = 1) And (cursorx = 1) Then launched = -1
#EndIf
End Macro
'--------------------
Macro ExitCC
#If %Def(%PB_CC32)
   If launched Then
      Input Flush
      stdout "Press any key to end"
      WaitKey$
   End If
#EndIf
End Macro
'--------------------
''MACRO zbs(x)=string$(x,0) 'also defined in SERPENT.BAS
#Include "SERPENT.INC"
Declare Function Hex2Show$(Buffer$)
'====================
Function PBMain&()
EnterCC
Local i&, key$, plain$, cipher$, shouldbe$, t$
Local ctx As ENCRYPTION_CONTEXT  ' defined in SERPENT.BAS
Serpent_Init ctx
'-- Standard Serpent test vectors:
'-- 256-bit key
key      = Chr$(&h00,&h11,&h22,&h33,&h44,&h55,&h66,&h77,&h88,&h99,&haa,&hbb,&hcc,&hdd,&hee,&hff, _
                &hff,&hee,&hdd,&hcc,&hbb,&haa,&h99,&h88,&h77,&h66,&h55,&h44,&h33,&h22,&h11,&h00)
plain    = Chr$(&h10,&h32,&h54,&h76,&h98,&hba,&hdc,&hfe,&hef,&hcd,&hab,&h89,&h67,&h45,&h23,&h01)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&h93,&hdf,&h9a,&h3c,&haf,&he3,&h87,&hbd,&h99,&h9e,&heb,&he3,&h93,&ha1,&h7f,&hca)
t = "Key length (bits):" + Str$(Len(key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt
t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
key      =  Chr$(&h00,&h11,&h22,&h33,&h44,&h55,&h66,&h77,&h88,&h99,&haa,&hbb,&hcc,&hdd,&hee,&hff, _
                 &hff,&hee,&hdd,&hcc,&hbb,&haa,&h99,&h88,&h77,&h66,&h55,&h44,&h33,&h22,&h11,&h00)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol
'-- 192-bit key
key      = Chr$(&h88,&h99,&haa,&hbb,&hcc,&hdd,&hee,&hff,&hff,&hee,&hdd,&hcc,&hbb,&haa,&h99,&h88, _
                &h77,&h66,&h55,&h44,&h33,&h22,&h11,&h00)
plain    = Chr$(&h10,&h32,&h54,&h76,&h98,&hba,&hdc,&hfe,&hef,&hcd,&hab,&h89,&h67,&h45,&h23,&h01)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&hda,&h86,&h08,&h42,&hb7,&h20,&h80,&h2b,&hf4,&h04,&ha4,&hc7,&h10,&h34,&h87,&h9a)
t = t + "Key length (bits):" + Str$(Len(key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt
t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
key      = Chr$(&h88,&h99,&haa,&hbb,&hcc,&hdd,&hee,&hff,&hff,&hee,&hdd,&hcc,&hbb,&haa,&h99,&h88, _
                &h77,&h66,&h55,&h44,&h33,&h22,&h11,&h00)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol
'-- 128-bit key
key      = Chr$(&hff,&hee,&hdd,&hcc,&hbb,&haa,&h99,&h88,&h77,&h66,&h55,&h44,&h33,&h22,&h11,&h00)
plain    = Chr$(&h10,&h32,&h54,&h76,&h98,&hba,&hdc,&hfe,&hef,&hcd,&hab,&h89,&h67,&h45,&h23,&h01)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&hd5,&hba,&ha0,&h0a,&h4b,&hb9,&hd8,&ha7,&hc9,&h81,&hc8,&hdc,&h90,&hd8,&h9d,&h92)
t = t + "Key length (bits):" + Str$(Len(key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt
t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
key      = Chr$(&hff,&hee,&hdd,&hcc,&hbb,&haa,&h99,&h88,&h77,&h66,&h55,&h44,&h33,&h22,&h11,&h00)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol
mbox(t)
'============
ExitPBMain:
ExitCC
Exit Function
'============
DoEncrypt:
#If %Def(%VERIFY_IMPLEMENTATION)    ' Set in SERPENT.BAS
'-- Because test vectors are reversed in the published documentation, the following
'   action is necessary when verifying the implementation.
plain = StrReverse$(plain) : key = StrReverse$(key) : shouldbe = StrReverse$(shouldbe)
#EndIf
ctx.UserKey       = StrPtr(key)
ctx.UserKeyLength = Len(key)
ctx.InBlock       = StrPtr(plain)
ctx.OutBlock      = StrPtr(cipher)
If Set_Key&(ctx) Then
   For i = 1 To (Len(plain)\%BLOCKSIZE)  '<-- Required: (len(plain) mod 16) = 0
      EncryptBlock ctx
      ctx.InBlock  = ctx.InBlock  + %BLOCKSIZE
      ctx.OutBlock = ctx.OutBlock + %BLOCKSIZE
   Next i&
Else
   mbox("Error")
End If
'-- Burn the subkey
Poke$ Ctx.K, zbs(SizeOf(Ctx.K_Buffer))
Return
'============
DoDecrypt:
#If %Def(%VERIFY_IMPLEMENTATION)
key = StrReverse$(key)
#EndIf
ctx.UserKey       = StrPtr(key)
ctx.UserKeyLength = Len(key)
ctx.InBlock       = StrPtr(cipher)
ctx.OutBlock      = StrPtr(plain)
If Set_Key&(ctx) Then
   For i = 1 To (Len(plain)\%BLOCKSIZE)  '<-- Required: (len(plain) mod 16) = 0
      DecryptBlock ctx
      ctx.InBlock  = ctx.InBlock  + %BLOCKSIZE
      ctx.OutBlock = ctx.OutBlock + %BLOCKSIZE
   Next i
Else
   mbox("Error")
End If
#If %Def(%VERIFY_IMPLEMENTATION)
plain = StrReverse$(plain)
#EndIf
'-- Burn the subkey
Poke$ Ctx.K, zbs(SizeOf(Ctx.K_Buffer))
Return
End Function
'====================
Function Hex2Show$(Buffer$)
Register i&
Local t$, b As Byte Ptr
b = StrPtr(Buffer$)
For i = 0 To Len(Buffer$)-1
   t = t + Hex$(@b[i],2) + " "
Next i
Function = t
End Function
'-- end TESTBED.BAS
