
'
'
'
'
'
'
'=====================================================================
'                       Twofish Test Bed code
'               Compiles with either PBWIN 7.0+ or PBCC 3.0+
'=====================================================================
#Compile Exe
#Register None
#Dim All
'============
DefLng A-Z
%USEMACROS = 1
#Include "WIN32API.INC"

'--------------------
'-- Utility macros
'--------------------

#If %Def(%PB_Win32)
   Macro eol=$Cr
   Macro mbox(t)=MsgBox t
#ElseIf %Def(%PB_CC32)
   Macro eol=$CrLf
   Macro mbox(t)=stdout t
#EndIf

'--------------------
Macro EnterCC
#If %Def(%PB_CC32)
   Local launched&
   If (cursory = 1) And (cursorx = 1) Then launched = -1
#EndIf
End Macro

'--------------------
Macro ExitCC
#If %Def(%PB_CC32)
   If launched Then
      Input Flush
      stdout "Press any key to end"
      WaitKey$
   End If
#EndIf
End Macro

'--------------------
'MACRO zbs(x)=string$(x,0) 'also defined in TWOFISH.INC

'--------------------
Macro hex8(x)=Hex$(x,8)+"h"

#Include "TWOFISH.INC"
Declare Function Hex2Show$(Buffer$)

'====================
Function PBMain&()
Register i&
Local key$, plain$, cipher$, shouldbe$, t$
Local ctx As TWOFISH_CONTEXT  ' defined in TWOFISH.INC
EnterCC

'-- Standard Twofish test vectors (from ECB_IVAL.TXT)
'-- 128-bit key
key$     = Chr$(&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00)
plain    = Chr$(&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&h9F,&h58,&h9F,&h5C,&hF6,&h12,&h2C,&h32,&hB6,&hBF,&hEC,&h2F,&h2A,&hE8,&hC3,&h5A)
t =     "Key length (bits):" + Str$(Len(key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt

t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
key$     = Chr$(&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol

'-- 192-bit key
key      = Chr$(&h01,&h23,&h45,&h67,&h89,&hAB,&hCD,&hEF,&hFE,&hDC,&hBA,&h98,&h76,&h54,&h32,&h10, _
                &h00,&h11,&h22,&h33,&h44,&h55,&h66,&h77)
plain    = Chr$(&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&hCF,&hD1,&hD2,&hE5,&hA9,&hBE,&h9C,&hDF,&h50,&h1F,&h13,&hB8,&h92,&hBD,&h22,&h48)
t = t + "Key length (bits):" + Str$(Len(key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt

t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
key      = Chr$(&h01,&h23,&h45,&h67,&h89,&hAB,&hCD,&hEF,&hFE,&hDC,&hBA,&h98,&h76,&h54,&h32,&h10, _
                &h00,&h11,&h22,&h33,&h44,&h55,&h66,&h77)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol

'-- 256-bit key
key      = Chr$(&h01,&h23,&h45,&h67,&h89,&hAB,&hCD,&hEF,&hFE,&hDC,&hBA,&h98,&h76,&h54,&h32,&h10, _
                &h00,&h11,&h22,&h33,&h44,&h55,&h66,&h77,&h88,&h99,&hAA,&hBB,&hCC,&hDD,&hEE,&hFF)
plain    = Chr$(&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00)
cipher   = zbs(Len(plain))
shouldbe = Chr$(&h37,&h52,&h7B,&hE0,&h05,&h23,&h34,&hB8,&h9F,&h0C,&hFC,&hCA,&hE8,&h7C,&hFA,&h20)

t = t + "Key length (bits):" + Str$(Len(key)*8) + eol
t = t + "plain:    " + Hex2Show$(plain) + eol
GoSub DoEncrypt
t = t + "cipher:   " + Hex2Show$(cipher) + eol
t = t + "shouldbe: " + Hex2Show$(shouldbe) + eol
'-- Be sure to reload key$
key      = Chr$(&h01,&h23,&h45,&h67,&h89,&hAB,&hCD,&hEF,&hFE,&hDC,&hBA,&h98,&h76,&h54,&h32,&h10, _
                &h00,&h11,&h22,&h33,&h44,&h55,&h66,&h77,&h88,&h99,&hAA,&hBB,&hCC,&hDD,&hEE,&hFF)
GoSub DoDecrypt
t = t + "plain:    " + Hex2Show$(plain) + eol + eol
mbox(t)

Done:
ExitCC
Exit Function

'============
DoEncrypt:
ctx.action        = %ENCRYPT
ctx.UserKey       = StrPtr(key)
ctx.UserKeyLength = Len(key)
ctx.InBlock       = StrPtr(plain)
ctx.OutBlock      = StrPtr(cipher)
If Set_Key&(ctx) Then
   For i = 1 To (Len(plain)\%BLOCKSIZE)  '<-- Required: (len(plain$) mod 16) = 0
      EncryptBlock ctx
      ctx.InBlock  = ctx.InBlock  + %BLOCKSIZE
      ctx.OutBlock = ctx.OutBlock + %BLOCKSIZE
   Next i&
Else
   mbox("DoEncrypt SetKey Error")
End If
'-- Burn the subkey
If Ctx.S_Box Then ZeroMemory(Ctx.S_Box,SizeOf(Ctx.S_Box_Buffer))
If Ctx.XKey  Then ZeroMemory(Ctx.XKey, SizeOf(Ctx.XKey_Buffer))
Return

'============
DoDecrypt:
ctx.action        = %DECRYPT
ctx.UserKey       = StrPtr(key)
ctx.UserKeyLength = Len(key)
ctx.InBlock       = StrPtr(cipher)
ctx.OutBlock      = StrPtr(plain)
If Set_Key&(ctx) Then
   For i = 1 To (Len(plain$)\%BLOCKSIZE)  '<-- Required: (len(plain$) mod 16) = 0
      DecryptBlock ctx
      ctx.InBlock  = ctx.InBlock  + %BLOCKSIZE
      ctx.OutBlock = ctx.OutBlock + %BLOCKSIZE
   Next i
Else
   mbox("DoDecrypt SetKey Error")
End If
'-- Burn the subkey
If Ctx.S_Box Then ZeroMemory(Ctx.S_Box,SizeOf(Ctx.S_Box_Buffer))
If Ctx.XKey  Then ZeroMemory(Ctx.XKey, SizeOf(Ctx.XKey_Buffer))
Return
End Function


'====================
Function Hex2Show$(Buffer$)
Register i&
Local t$, b As Byte Ptr
b = StrPtr(Buffer$)
For i = 0 To Len(Buffer$)-1
   t = t + Hex$(@b[i],2) + " "
Next i
Function = t
End Function
'-- end TESTBED.BAS
