#If 0

=====================================================================
                        Serpent Encryption
=====================================================================

The authors Of the Serpent encryption algorithm have placed it In the
public domain And make no restrictions On its use. The Serpent home
Page Is accessible At: http://www.cl.cam.ac.uk/~rja14/serpent.html

From the Serpent home Page:
"Serpent is a 128-bit block cipher designed by Ross Anderson, Eli
Biham And Lars Knudsen As a candidate For the Advanced Encryption
Standard. It was a finalist In the AES competition. The winner,
Rijndael, got 86 votes At the last AES conference While Serpent got 59
votes, Twofish 31 votes, RC6 23 votes And MARS 13 votes. So NIST's
choice Of Rijndael As the AES was Not surprising, And we had To
Content ourselves With silver In the `encryption olympics'. Serpent
And Rijndael are In fact somewhat similar; the Main difference Is that
Rijndael Is faster (having fewer rounds) but Serpent Is more secure."

The PowerBASIC implementation appearing here Is based On that Of Brian
Gladman, which Is available At: http://fp.gladman.plus.com/cryptography_technology/
The following notice appears In Gladman's Serpent code.
--------------------------------------------------------------------
 This Is an independent implementation Of the encryption algorithm:
       Serpent by Ross Anderson, Eli Biham And Lars Knudsen
 which Is a candidate algorithm In the Advanced Encryption Standard
 programme Of the US National Institute Of Standards And Technology.
 Copyright In this implementation Is held by Dr B R Gladman but I
 hereby give permission For its Free direct Or derivative use subject
 To acknowledgment Of its origin And compliance With Any conditions
 that the originators Of the algorithm place On its exploitation.
 Dr Brian Gladman (gladman@seven77.demon.co.uk) 14th January 1999
-------------------------------------------------------------------
The PB implementation Is hereby placed In the public domain.  Use it
As you wish.  My hope Is discourage reliance On home-grown encryption
schemes In favor Of well-examined, strong, freely available
algorithms.

In this posting, test-bed Code appears below the SERPENT.BAS file
contents.  All Code requires compiler releases 3.0/7.0 Or later. Implementation Notes
-- The algorithm operates On plaintext blocks Of 16 bytes.  Encryption
Of shorter blocks Is possible Only by padding the plaintext (usually
With zero bytes), which can be accomplished through several methods.
The simplest Of them assumes that the final Byte Of plaintext always
identifies the number Of bytes Of padding added, including the final
Byte itself.
 Examples:
   total plaintext bytes         = 30
   plaintext blocks encrypted:   = 2
   final block                   = Chr$(x1 To x14) + Chr$(0,2)
   total plaintext bytes         = 40
   plaintext blocks encrypted:   = 3
   final block                   = Chr$(x1 To x8) + Chr$(0,0,0,0,0,0,0,8)
-- Encryption key lengths can Range From 1 To 32 bytes (8 To 256
Bits).
-- Implementation here Is handled through an #Include file.  No Global
Data is employed.
-- As presented, the Code does Not supply a ready-To-use encryption
application.  It offers necessary pieces Only, As well As an
illustration Of their use.  Always keep In mind that most encryption
Is broken because Of implementation flaws And weaknesses.
-- Like most encryption algorithms, Serpent was designed On big-endian
systems.  For this reason, little-endian systems Return correct test
vector results Only through considerable Byte-swapping, With
efficiency suffering As a result.  Because it adds Nothing To the
encryption security, an efficient implementation should avoid the
Byte-swapping.  Here the equate %VERIFY_IMPLEMENTATION can be remmed
To avoid this Byte-swapping.
-- Because Of the methods Of Data handling required for most
encryption And hashing, PowerBASIC's LONGs should be used to assure
correct Bit-level results (As well As additional Speed).
Greg Turgeon 07/2002
#EndIf


'-- Rem this equate for any use other than verification of implementation.
%VERIFY_IMPLEMENTATION = 1
%BLOCKSIZE      = 16
%KEY_SIZE       = 32
%SUBKEY_SIZE    = 140
%MIN_KEY_SIZE   = 1
%MAX_KEY_SIZE   = 32
'-- Note: Strings (UserKey, etc) are processed
'   as 32-bit values, so LONG PTRs required
Type ENCRYPTION_CONTEXT
UserKeyLength  As Long
UserKey        As Long Ptr
InBlock        As Long Ptr
OutBlock       As Long Ptr
K              As Long Ptr                  '<-- pointer to subkey buffer
K_Buffer       As String * (%SUBKEY_SIZE*4) '<-- subkey buffer itself
End Type
Declare Sub Serpent_Init(Ctx As ENCRYPTION_CONTEXT)
Declare Function Set_Key&(Ctx As ENCRYPTION_CONTEXT)
Declare Function EncryptBlock&(Ctx As ENCRYPTION_CONTEXT)
Declare Function DecryptBlock&(Ctx As ENCRYPTION_CONTEXT)

'--------------------
' Utility macros
'--------------------
'--------------------
Macro zbs(x) = String$(x,0)
'--------------------
Macro Function byte_swap(x)
!  mov      eax, x
!  bswap    eax
!  mov      x, eax
End Macro = x
'--------------------
Macro Function shiftl(x,shiftval)
retval = x
!  shl   retval, shiftval
End Macro = retval
'--------------------
Macro Function rotr(x,rotval)
retval = x
!  mov   ecx, rotval
!  ror   retval, cl
End Macro = retval
'--------------------
Macro Function rotl(x,rotval)
retval = x
!  mov   ecx, rotval
!  rol   retval, cl
End Macro = retval
'--------------------
Macro Function rotl_11(x)
!  mov   ecx, 11
!  rol   lk, cl
End Macro = x
'--------------------
Macro make_marker(i,klen,lk)
!  mov   ecx, klen
!  mov   eax, ecx
!  shr   eax, 5
!  mov   i, eax
!  and   ecx, 31
!  mov   eax, 1
!  shl   eax, cl
!  mov   lk, eax
End Macro

'--------------------
'Serpent macros
'--------------------
Macro sb0(a,b,c,d,e,f,g,h)
t1 = a Xor d    : t2  = a And d   : t3 = c Xor t1   : t6 = b And t1
t4 = b Xor t3   : t10 = Not t3    : h = t2 Xor t4   : t7 = a Xor t6
t14 = Not t7    : t8 = c Or t7    : t11 = t3 Xor t7 : g = t4 Xor t8
t12 = h And t11 : f = t10 Xor t12 : e = t12 Xor t14
End Macro
'--------------------
Macro ib0(a,b,c,d,e,f,g,h)
t1 = Not a     : t2 = a Xor b     : t3 = t1 Or t2   : t4 = d Xor t3
t7 = d And t2  : t5 = c Xor t4    : t8 = t1 Xor t7  : g = t2 Xor t5
t11 = a And t4 : t9 = g And t8    : t14 = t5 Xor t8 : f = t4 Xor t9
t12 = t5 Or f  : h  = t11 Xor t12 : e = h Xor t14
End Macro
'--------------------
Macro sb1(a,b,c,d,e,f,g,h)
t1 = Not a       : t2 = b Xor t1 : t3 = a Or t2    : t4 = d Or t2
t5 = c Xor t3    : g = d Xor t5  : t7 = b Xor t4   : t8 = t2 Xor g
t9 = t5 And t7   : h = t8 Xor t9 : t11 = t5 Xor t7 : f = h Xor t11
t13 = t8 And t11 : e = t5 Xor t13
End Macro
'--------------------
Macro ib1(a,b,c,d,e,f,g,h)
t1 = a Xor d  : t2 = a And b    : t3 = b Xor c  : t4  = a Xor t3
t5 = b Or d   : t7 = c Or t1    : h = t4 Xor t5 : t8  = b Xor t7
t11 = Not t2  : t9 = t4 And t8  : f = t1 Xor t9 : t13 = t9 Xor t11
t12 = h And f : g = t12 Xor t13 : t15 = a And d : t16 = c Xor t13
e = t15 Xor t16
End Macro
'--------------------
Macro sb2(a,b,c,d,e,f,g,h)
t1 = Not a     : t2 = b Xor d  : t3 = c And t1   : t13 = d Or t1
e = t2 Xor t3  : t5 = c Xor t1 : t6 = c Xor e    : t7 = b And t6
t10 = e Or t5  : h = t5 Xor t7 : t9 = d Or t7    : t11 = t9 And t10
t14 = t2 Xor h : g = a Xor t11 : t15 = g Xor t13 : f = t14 Xor t15
End Macro
'--------------------
Macro ib2(a,b,c,d,e,f,g,h)
t1 = b Xor d  : t2 = Not t1     : t3 = a Xor c     : t4 = c Xor t1
t7 = a Or t2  : t5 = b And t4   : t8 = d Xor t7    : t11 = Not t4
e = t3 Xor t5 : t9 = t3 Or t8   : t14 = d And t11  : h = t1 Xor t9
t12 = e Or h  : f = t11 Xor t12 : t15 = t3 Xor t12 : g = t14 Xor t15
End Macro
'--------------------
Macro sb3(a,b,c,d,e,f,g,h)
t1 = a Xor c   : t2 = d Xor t1   : t3 = a And t2   : t4 = d Xor t3
t5 = b And t4  : g = t2 Xor t5   : t7 = a Or g     : t8 = b Or d
t11 = a Or d   : t9 = t4 And t7  : f = t8 Xor t9   : t12 = b Xor t11
t13 = g Xor t9 : t15 = t3 Xor t8 : h = t12 Xor t13 : t16 = c And t15
e = t12 Xor t16
End Macro
'--------------------
Macro ib3(a,b,c,d,e,f,g,h)
t1 = b Xor c    : t2 = b Or c    : t3 = a Xor c     : t7 = a Xor d
t4 = t2 Xor t3  : t5 = d Or t4   : t9 = t2 Xor t7   : e = t1 Xor t5
t8 = t1 Or t5   : t11 = a And t4 : g = t8 Xor t9    : t12 = e Or t9
f = t11 Xor t12 : t14 = a And g  : t15 = t2 Xor t14 : t16 = e And t15
h = t4 Xor t16
End Macro
'--------------------
Macro sb4(a,b,c,d,e,f,g,h)
t1 = a Xor d   : t2 = d And t1   : t3 = c Xor t2    : t4 = b Or t3
h = t1 Xor t4  : t6 = Not b      : t7 = t1 Or t6    : e = t3 Xor t7
t9 = a And e   : t10 = t1 Xor t6 : t11 = t4 And t10 : g = t9 Xor t11
t13 = a Xor t3 : t14 = t10 And g : f = t13 Xor t14
End Macro
'--------------------
Macro ib4(a,b,c,d,e,f,g,h)
t1 = c Xor d   : t2 = c Or d   : t3 = b Xor t2    : t4 = a And t3
f = t1 Xor t4  : t6 = a Xor d  : t7 = b Or d      : t8 = t6 And t7
h = t3 Xor t8  : t10 = Not a   : t11 = c Xor h    : t12 = t10 Or t11
e = t3 Xor t12 : t14 = c Or t4 : t15 = t7 Xor t14 : t16 = h Or t10
g = t15 Xor t16
End Macro
'--------------------
Macro sb5(a,b,c,d,e,f,g,h)
t1 = Not a     : t2 = a Xor b    : t3 = a Xor d    : t4 = c Xor t1
t5 = t2 Or t3  : e = t4 Xor t5   : t7 = d And e    : t8 = t2 Xor e
t10 = t1 Or e  : f = t7 Xor t8   : t11 = t2 Or t7  : t12 = t3 Xor t10
t14 = b Xor t7 : g = t11 Xor t12 : t15 = f And t12 : h = t14 Xor t15
End Macro
'--------------------
Macro ib5(a,b,c,d,e,f,g,h)
t1 = Not c    : t2 = b And t1   : t3 = d Xor t2   : t4 = a And t3
t5 = b Xor t1 : h = t4 Xor t5   : t7 = b Or h     : t8 = a And t7
f = t3 Xor t8 : t10 = a Or d    : t11 = t1 Xor t7 : e = t10 Xor t11
t13 = a Xor c : t14 = b And t10 : t15 = t4 Or t13 : g = t14 Xor t15
End Macro
'--------------------
Macro sb6(a,b,c,d,e,f,g,h)
t1 = Not a    : t2 = a Xor d     : t3 = b Xor t2 : t4    = t1 Or t2
t5 = c Xor t4 : f = b Xor t5     : t13 = Not t5  : t7    = t2 Or f
t8 = d Xor t7 : t9 = t5 And t8   : g = t3 Xor t9 : t11   = t5 Xor t8
e = g Xor t11 : t14 = t3 And t11 : h = t13 Xor t14
End Macro
'--------------------
Macro ib6(a,b,c,d,e,f,g,h)
t1 = Not a     : t2 = a Xor b     : t3 = c Xor t2 : t4 = c Or t1
t5 = d Xor t4  : t13 = d And t1   : f = t3 Xor t5 : t7 = t3 And t5
t8 = t2 Xor t7 : t9 = b Or t8     : h = t5 Xor t9 : t11 = b Or h
e = t8 Xor t11 : t14 = t3 Xor t11 : g = t13 Xor t14
End Macro
'--------------------
Macro sb7(a,b,c,d,e,f,g,h)
t1 = Not c     : t2 = b Xor c    : t3 = b Or t1    : t4 = d Xor t3
t5 = a And t4  : t7 = a Xor d    : h = t2 Xor t5   : t8 = b Xor t5
t9 = t2 Or t8  : t11 = d And t3  : f = t7 Xor t9   : t12 = t5 Xor f
t15 = t1 Or t4 : t13 = h And t12 : g = t11 Xor t13 : t16 = t12 Xor g
e = t15 Xor t16
End Macro
'--------------------
Macro ib7(a,b,c,d,e,f,g,h)
t1 = a And b    : t2 = a Or b   : t3 = c Or t1   : t4 = d And t2
h = t3 Xor t4   : t6 = Not d    : t7 = b Xor t4  : t8 = h Xor t6
t11 = c Xor t7  : t9 = t7 Or t8 : f = a Xor t9   : t12 = d Or f
e = t11 Xor t12 : t14 = a And h : t15 = t3 Xor f : t16 = e Xor t14
g = t15 Xor t16
End Macro
'--------------------
Macro k_xor(r,a,b,c,d)
a = a Xor @k[4*r+8]  : b = b Xor @k[4*r+9]
c = c Xor @k[4*r+10] : d = d Xor @k[4*r+11]
End Macro
'--------------------
Macro k_set(r,a,b,c,d)
a = @k[4*r+8]  : b = @k[4*r+9]
c = @k[4*r+10] : d = @k[4*r+11]
End Macro
'--------------------
Macro k_get(r,a,b,c,d)
@k[4*r+8] = a  : @k[4*r+9] = b
@k[4*r+10] = c : @k[4*r+11] = d
End Macro
'--------------------
Macro rot(a,b,c,d)
a = rotl(a,13)
c = rotl(c,3)
d = (d Xor c) Xor shiftl(a,3)
b = b Xor a Xor c
d = rotl(d,7)
b = rotl(b,1)
a = a Xor b Xor d
c = (c Xor d) Xor shiftl(b,7)
a = rotl(a,5)
c = rotl(c,22)
End Macro
'--------------------
Macro irot(a,b,c,d)
c = rotr(c,22)
a = rotr(a,5)
c = (c Xor d) Xor shiftl(b,7)
a = a Xor b Xor d
d = rotr(d,7)
b = rotr(b,1)
d = (d Xor c) Xor shiftl(a,3)
b = b Xor a Xor c
c = rotr(c,3)
a = rotr(a,13)
End Macro
'====================

Sub Serpent_Init(Ctx As ENCRYPTION_CONTEXT)
Ctx.K_Buffer = zbs(%SUBKEY_SIZE*4)
Ctx.K        = VarPtr(Ctx.K_BUFFER)
End Sub
'====================

Function Set_Key&(Ctx As ENCRYPTION_CONTEXT)
'-- Returns %TRUE on success
Local k As Long Ptr, uk As Long Ptr
Local i&, j&, lk&, x&
Local a&, b&, c&, d&, e&, f&, g&, h&
Local t1&, t2&, t3&, t4&, t5&, t6&, t7&, t8&
Local t9&, t10&, t11&, t12&, t13&, t14&, t15&, t16&
Local retval& 'for macro use
'-- Verify that Serpent_Init has been called
If Ctx.K = 0 Then
   Function = 0 : Exit Function
End If
x = Ctx.UserKeyLength
If(x < %MIN_KEY_SIZE) Or (x > %MAX_KEY_SIZE) Then
   Function = 0 : Exit Function
End If
'-- bytes --> bits
x = (x * 8)
uk = Ctx.UserKey : k = Ctx.K  'local copies
i = 0 : lk = ((x + 31) \ 32)
Do While (i < lk)
   #If %Def(%VERIFY_IMPLEMENTATION)
   j = @uk[lk-i-1] : @k[i] = byte_swap(j)
   #Else
   @k[i] = @uk[lk-i-1]
   #EndIf
   Incr i
Loop
If (x < 256) Then
   Do While (i < 8)
      @k[i] = 0 : Incr i
   Loop
   make_marker(i,x,lk)
   @k[i] = @k[i] And (lk-1) Or lk
End If
For i = 0 To 131
   lk = @k[i] Xor @k[i+3] Xor @k[i+5] Xor @k[i+7] Xor &h9e3779b9 Xor i
   @k[i+8] = rotl_11(lk)
Next i
k_set(0,a,b,c,d)  : sb3(a,b,c,d,e,f,g,h) : k_get(0,e,f,g,h)
k_set(1,a,b,c,d)  : sb2(a,b,c,d,e,f,g,h) : k_get(1,e,f,g,h)
k_set(2,a,b,c,d)  : sb1(a,b,c,d,e,f,g,h) : k_get(2,e,f,g,h)
k_set(3,a,b,c,d)  : sb0(a,b,c,d,e,f,g,h) : k_get(3,e,f,g,h)
k_set(4,a,b,c,d)  : sb7(a,b,c,d,e,f,g,h) : k_get(4,e,f,g,h)
k_set(5,a,b,c,d)  : sb6(a,b,c,d,e,f,g,h) : k_get(5,e,f,g,h)
k_set(6,a,b,c,d)  : sb5(a,b,c,d,e,f,g,h) : k_get(6,e,f,g,h)
k_set(7,a,b,c,d)  : sb4(a,b,c,d,e,f,g,h) : k_get(7,e,f,g,h)
k_set(8,a,b,c,d)  : sb3(a,b,c,d,e,f,g,h) : k_get(8,e,f,g,h)
k_set(9,a,b,c,d)  : sb2(a,b,c,d,e,f,g,h) : k_get(9,e,f,g,h)
k_set(10,a,b,c,d) : sb1(a,b,c,d,e,f,g,h) : k_get(10,e,f,g,h)
k_set(11,a,b,c,d) : sb0(a,b,c,d,e,f,g,h) : k_get(11,e,f,g,h)
k_set(12,a,b,c,d) : sb7(a,b,c,d,e,f,g,h) : k_get(12,e,f,g,h)
k_set(13,a,b,c,d) : sb6(a,b,c,d,e,f,g,h) : k_get(13,e,f,g,h)
k_set(14,a,b,c,d) : sb5(a,b,c,d,e,f,g,h) : k_get(14,e,f,g,h)
k_set(15,a,b,c,d) : sb4(a,b,c,d,e,f,g,h) : k_get(15,e,f,g,h)
k_set(16,a,b,c,d) : sb3(a,b,c,d,e,f,g,h) : k_get(16,e,f,g,h)
k_set(17,a,b,c,d) : sb2(a,b,c,d,e,f,g,h) : k_get(17,e,f,g,h)
k_set(18,a,b,c,d) : sb1(a,b,c,d,e,f,g,h) : k_get(18,e,f,g,h)
k_set(19,a,b,c,d) : sb0(a,b,c,d,e,f,g,h) : k_get(19,e,f,g,h)
k_set(20,a,b,c,d) : sb7(a,b,c,d,e,f,g,h) : k_get(20,e,f,g,h)
k_set(21,a,b,c,d) : sb6(a,b,c,d,e,f,g,h) : k_get(21,e,f,g,h)
k_set(22,a,b,c,d) : sb5(a,b,c,d,e,f,g,h) : k_get(22,e,f,g,h)
k_set(23,a,b,c,d) : sb4(a,b,c,d,e,f,g,h) : k_get(23,e,f,g,h)
k_set(24,a,b,c,d) : sb3(a,b,c,d,e,f,g,h) : k_get(24,e,f,g,h)
k_set(25,a,b,c,d) : sb2(a,b,c,d,e,f,g,h) : k_get(25,e,f,g,h)
k_set(26,a,b,c,d) : sb1(a,b,c,d,e,f,g,h) : k_get(26,e,f,g,h)
k_set(27,a,b,c,d) : sb0(a,b,c,d,e,f,g,h) : k_get(27,e,f,g,h)
k_set(28,a,b,c,d) : sb7(a,b,c,d,e,f,g,h) : k_get(28,e,f,g,h)
k_set(29,a,b,c,d) : sb6(a,b,c,d,e,f,g,h) : k_get(29,e,f,g,h)
k_set(30,a,b,c,d) : sb5(a,b,c,d,e,f,g,h) : k_get(30,e,f,g,h)
k_set(31,a,b,c,d) : sb4(a,b,c,d,e,f,g,h) : k_get(31,e,f,g,h)
k_set(32,a,b,c,d) : sb3(a,b,c,d,e,f,g,h) : k_get(32,e,f,g,h)
Function = -1
End Function
'====================

Function EncryptBlock&(CTX As ENCRYPTION_CONTEXT)
Local a&, b&, c&, d&, e&, f&, g&, h&
Local t1&, t2&, t3&, t4&, t5&, t6&, t7&, t8&
Local t9&, t10&, t11&, t12&, t13&, t14&, t15&, t16&
Local k As Long Ptr
Local retval& 'for macro use
#If %Def(%VERIFY_IMPLEMENTATION)
a = Ctx.@InBlock[3] : a = byte_swap(a)
b = Ctx.@InBlock[2] : b = byte_swap(b)
c = Ctx.@InBlock[1] : c = byte_swap(c)
d = Ctx.@InBlock[0] : d = byte_swap(d)
#Else
a = Ctx.@InBlock[3]
b = Ctx.@InBlock[2]
c = Ctx.@InBlock[1]
d = Ctx.@InBlock[0]
#EndIf
k = Ctx.K 'local copy
k_xor(0,a,b,c,d)  : sb0(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(1,e,f,g,h)  : sb1(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(2,a,b,c,d)  : sb2(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(3,e,f,g,h)  : sb3(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(4,a,b,c,d)  : sb4(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(5,e,f,g,h)  : sb5(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(6,a,b,c,d)  : sb6(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(7,e,f,g,h)  : sb7(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(8,a,b,c,d)  : sb0(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(9,e,f,g,h)  : sb1(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(10,a,b,c,d) : sb2(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(11,e,f,g,h) : sb3(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(12,a,b,c,d) : sb4(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(13,e,f,g,h) : sb5(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(14,a,b,c,d) : sb6(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(15,e,f,g,h) : sb7(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(16,a,b,c,d) : sb0(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(17,e,f,g,h) : sb1(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(18,a,b,c,d) : sb2(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(19,e,f,g,h) : sb3(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(20,a,b,c,d) : sb4(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(21,e,f,g,h) : sb5(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(22,a,b,c,d) : sb6(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(23,e,f,g,h) : sb7(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(24,a,b,c,d) : sb0(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(25,e,f,g,h) : sb1(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(26,a,b,c,d) : sb2(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(27,e,f,g,h) : sb3(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(28,a,b,c,d) : sb4(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(29,e,f,g,h) : sb5(e,f,g,h,a,b,c,d) : rot(a,b,c,d)
k_xor(30,a,b,c,d) : sb6(a,b,c,d,e,f,g,h) : rot(e,f,g,h)
k_xor(31,e,f,g,h) : sb7(e,f,g,h,a,b,c,d)
k_xor(32,a,b,c,d)
#If %Def(%VERIFY_IMPLEMENTATION)
Ctx.@OutBlock[3] = byte_swap(a)
Ctx.@OutBlock[2] = byte_swap(b)
Ctx.@OutBlock[1] = byte_swap(c)
Ctx.@OutBlock[0] = byte_swap(d)
#Else
Ctx.@OutBlock[3] = a
Ctx.@OutBlock[2] = b
Ctx.@OutBlock[1] = c
Ctx.@OutBlock[0] = d
#EndIf
End Function
'====================

Function DecryptBlock&(CTX As ENCRYPTION_CONTEXT)
Local a&, b&, c&, d&, e&, f&, g&, h&
Local t1&, t2&, t3&, t4&, t5&, t6&, t7&, t8&
Local t9&, t10&, t11&, t12&, t13&, t14&, t15&, t16&
Local retval& 'for macro use
Local k As Long Ptr
#If %Def(%VERIFY_IMPLEMENTATION)
a = Ctx.@InBlock[3] : a = byte_swap(a)
b = Ctx.@InBlock[2] : b = byte_swap(b)
c = Ctx.@InBlock[1] : c = byte_swap(c)
d = Ctx.@InBlock[0] : d = byte_swap(d)
#Else
a = Ctx.@InBlock[3]
b = Ctx.@InBlock[2]
c = Ctx.@InBlock[1]
d = Ctx.@InBlock[0]
#EndIf
k = Ctx.K 'local copy
k_xor(32,a,b,c,d)
                ib7(a,b,c,d,e,f,g,h) : k_xor(31,e,f,g,h)
irot(e,f,g,h) : ib6(e,f,g,h,a,b,c,d) : k_xor(30,a,b,c,d)
irot(a,b,c,d) : ib5(a,b,c,d,e,f,g,h) : k_xor(29,e,f,g,h)
irot(e,f,g,h) : ib4(e,f,g,h,a,b,c,d) : k_xor(28,a,b,c,d)
irot(a,b,c,d) : ib3(a,b,c,d,e,f,g,h) : k_xor(27,e,f,g,h)
irot(e,f,g,h) : ib2(e,f,g,h,a,b,c,d) : k_xor(26,a,b,c,d)
irot(a,b,c,d) : ib1(a,b,c,d,e,f,g,h) : k_xor(25,e,f,g,h)
irot(e,f,g,h) : ib0(e,f,g,h,a,b,c,d) : k_xor(24,a,b,c,d)
irot(a,b,c,d) : ib7(a,b,c,d,e,f,g,h) : k_xor(23,e,f,g,h)
irot(e,f,g,h) : ib6(e,f,g,h,a,b,c,d) : k_xor(22,a,b,c,d)
irot(a,b,c,d) : ib5(a,b,c,d,e,f,g,h) : k_xor(21,e,f,g,h)
irot(e,f,g,h) : ib4(e,f,g,h,a,b,c,d) : k_xor(20,a,b,c,d)
irot(a,b,c,d) : ib3(a,b,c,d,e,f,g,h) : k_xor(19,e,f,g,h)
irot(e,f,g,h) : ib2(e,f,g,h,a,b,c,d) : k_xor(18,a,b,c,d)
irot(a,b,c,d) : ib1(a,b,c,d,e,f,g,h) : k_xor(17,e,f,g,h)
irot(e,f,g,h) : ib0(e,f,g,h,a,b,c,d) : k_xor(16,a,b,c,d)
irot(a,b,c,d) : ib7(a,b,c,d,e,f,g,h) : k_xor(15,e,f,g,h)
irot(e,f,g,h) : ib6(e,f,g,h,a,b,c,d) : k_xor(14,a,b,c,d)
irot(a,b,c,d) : ib5(a,b,c,d,e,f,g,h) : k_xor(13,e,f,g,h)
irot(e,f,g,h) : ib4(e,f,g,h,a,b,c,d) : k_xor(12,a,b,c,d)
irot(a,b,c,d) : ib3(a,b,c,d,e,f,g,h) : k_xor(11,e,f,g,h)
irot(e,f,g,h) : ib2(e,f,g,h,a,b,c,d) : k_xor(10,a,b,c,d)
irot(a,b,c,d) : ib1(a,b,c,d,e,f,g,h) : k_xor( 9,e,f,g,h)
irot(e,f,g,h) : ib0(e,f,g,h,a,b,c,d) : k_xor( 8,a,b,c,d)
irot(a,b,c,d) : ib7(a,b,c,d,e,f,g,h) : k_xor( 7,e,f,g,h)
irot(e,f,g,h) : ib6(e,f,g,h,a,b,c,d) : k_xor( 6,a,b,c,d)
irot(a,b,c,d) : ib5(a,b,c,d,e,f,g,h) : k_xor( 5,e,f,g,h)
irot(e,f,g,h) : ib4(e,f,g,h,a,b,c,d) : k_xor( 4,a,b,c,d)
irot(a,b,c,d) : ib3(a,b,c,d,e,f,g,h) : k_xor( 3,e,f,g,h)
irot(e,f,g,h) : ib2(e,f,g,h,a,b,c,d) : k_xor( 2,a,b,c,d)
irot(a,b,c,d) : ib1(a,b,c,d,e,f,g,h) : k_xor( 1,e,f,g,h)
irot(e,f,g,h) : ib0(e,f,g,h,a,b,c,d) : k_xor( 0,a,b,c,d)
#If %Def(%VERIFY_IMPLEMENTATION)
Ctx.@OutBlock[3] = byte_swap(a)
Ctx.@OutBlock[2] = byte_swap(b)
Ctx.@OutBlock[1] = byte_swap(c)
Ctx.@OutBlock[0] = byte_swap(d)
#Else
Ctx.@OutBlock[3] = a
Ctx.@OutBlock[2] = b
Ctx.@OutBlock[1] = c
Ctx.@OutBlock[0] = d
#EndIf
End Function
'-- end SERPENT.BAS
